# ory_kratos_client
Welcome to the ORY Kratos HTTP API documentation!

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.5.5-alpha.4
- Build package: org.openapitools.codegen.languages.DartClientCodegen

## Requirements

Dart 2.0 or later

## Installation & Usage

### Github
If this Dart package is published to Github, add the following dependency to your pubspec.yaml
```
dependencies:
  ory_kratos_client:
    git: https://github.com/ory/sdk.git
```

### Local
To use the package in your local drive, add the following dependency to your pubspec.yaml
```
dependencies:
  ory_kratos_client:
    path: /path/to/ory_kratos_client
```

## Tests

TODO

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ory_kratos_client/api.dart';


final api_instance = AdminApi();
final body = CreateIdentity(); // CreateIdentity | 

try {
    final result = api_instance.createIdentity(body);
    print(result);
} catch (e) {
    print('Exception when calling AdminApi->createIdentity: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AdminApi* | [**createIdentity**](doc//AdminApi.md#createidentity) | **POST** /identities | Create an Identity
*AdminApi* | [**createRecoveryLink**](doc//AdminApi.md#createrecoverylink) | **POST** /recovery/link | Create a Recovery Link
*AdminApi* | [**deleteIdentity**](doc//AdminApi.md#deleteidentity) | **DELETE** /identities/{id} | Delete an Identity
*AdminApi* | [**getIdentity**](doc//AdminApi.md#getidentity) | **GET** /identities/{id} | Get an Identity
*AdminApi* | [**getSchema**](doc//AdminApi.md#getschema) | **GET** /schemas/{id} | 
*AdminApi* | [**getSelfServiceError**](doc//AdminApi.md#getselfserviceerror) | **GET** /self-service/errors | Get User-Facing Self-Service Errors
*AdminApi* | [**getSelfServiceLoginFlow**](doc//AdminApi.md#getselfserviceloginflow) | **GET** /self-service/login/flows | Get Login Flow
*AdminApi* | [**getSelfServiceRecoveryFlow**](doc//AdminApi.md#getselfservicerecoveryflow) | **GET** /self-service/recovery/flows | Get information about a recovery flow
*AdminApi* | [**getSelfServiceRegistrationFlow**](doc//AdminApi.md#getselfserviceregistrationflow) | **GET** /self-service/registration/flows | Get Registration Flow
*AdminApi* | [**getSelfServiceSettingsFlow**](doc//AdminApi.md#getselfservicesettingsflow) | **GET** /self-service/settings/flows | Get Settings Flow
*AdminApi* | [**getSelfServiceVerificationFlow**](doc//AdminApi.md#getselfserviceverificationflow) | **GET** /self-service/verification/flows | Get Verification Flow
*AdminApi* | [**listIdentities**](doc//AdminApi.md#listidentities) | **GET** /identities | List Identities
*AdminApi* | [**prometheus**](doc//AdminApi.md#prometheus) | **GET** /metrics/prometheus | Get snapshot metrics from the Hydra service. If you're using k8s, you can then add annotations to your deployment like so:
*AdminApi* | [**updateIdentity**](doc//AdminApi.md#updateidentity) | **PUT** /identities/{id} | Update an Identity
*HealthApi* | [**isInstanceAlive**](doc//HealthApi.md#isinstancealive) | **GET** /health/alive | Check alive status
*HealthApi* | [**isInstanceReady**](doc//HealthApi.md#isinstanceready) | **GET** /health/ready | Check readiness status
*PublicApi* | [**completeSelfServiceBrowserSettingsOIDCSettingsFlow**](doc//PublicApi.md#completeselfservicebrowsersettingsoidcsettingsflow) | **POST** /self-service/browser/flows/registration/strategies/oidc/settings/connections | Complete the Browser-Based Settings Flow for the OpenID Connect Strategy
*PublicApi* | [**completeSelfServiceLoginFlowWithPasswordMethod**](doc//PublicApi.md#completeselfserviceloginflowwithpasswordmethod) | **POST** /self-service/login/methods/password | Complete Login Flow with Username/Email Password Method
*PublicApi* | [**completeSelfServiceRecoveryFlowWithLinkMethod**](doc//PublicApi.md#completeselfservicerecoveryflowwithlinkmethod) | **POST** /self-service/recovery/methods/link | Complete Recovery Flow with Link Method
*PublicApi* | [**completeSelfServiceRegistrationFlowWithPasswordMethod**](doc//PublicApi.md#completeselfserviceregistrationflowwithpasswordmethod) | **POST** /self-service/registration/methods/password | Complete Registration Flow with Username/Email Password Method
*PublicApi* | [**completeSelfServiceSettingsFlowWithPasswordMethod**](doc//PublicApi.md#completeselfservicesettingsflowwithpasswordmethod) | **POST** /self-service/settings/methods/password | Complete Settings Flow with Username/Email Password Method
*PublicApi* | [**completeSelfServiceSettingsFlowWithProfileMethod**](doc//PublicApi.md#completeselfservicesettingsflowwithprofilemethod) | **POST** /self-service/settings/methods/profile | Complete Settings Flow with Profile Method
*PublicApi* | [**completeSelfServiceVerificationFlowWithLinkMethod**](doc//PublicApi.md#completeselfserviceverificationflowwithlinkmethod) | **POST** /self-service/verification/methods/link | Complete Verification Flow with Link Method
*PublicApi* | [**getSchema**](doc//PublicApi.md#getschema) | **GET** /schemas/{id} | 
*PublicApi* | [**getSelfServiceError**](doc//PublicApi.md#getselfserviceerror) | **GET** /self-service/errors | Get User-Facing Self-Service Errors
*PublicApi* | [**getSelfServiceLoginFlow**](doc//PublicApi.md#getselfserviceloginflow) | **GET** /self-service/login/flows | Get Login Flow
*PublicApi* | [**getSelfServiceRecoveryFlow**](doc//PublicApi.md#getselfservicerecoveryflow) | **GET** /self-service/recovery/flows | Get information about a recovery flow
*PublicApi* | [**getSelfServiceRegistrationFlow**](doc//PublicApi.md#getselfserviceregistrationflow) | **GET** /self-service/registration/flows | Get Registration Flow
*PublicApi* | [**getSelfServiceSettingsFlow**](doc//PublicApi.md#getselfservicesettingsflow) | **GET** /self-service/settings/flows | Get Settings Flow
*PublicApi* | [**getSelfServiceVerificationFlow**](doc//PublicApi.md#getselfserviceverificationflow) | **GET** /self-service/verification/flows | Get Verification Flow
*PublicApi* | [**initializeSelfServiceBrowserLogoutFlow**](doc//PublicApi.md#initializeselfservicebrowserlogoutflow) | **GET** /self-service/browser/flows/logout | Initialize Browser-Based Logout User Flow
*PublicApi* | [**initializeSelfServiceLoginViaAPIFlow**](doc//PublicApi.md#initializeselfserviceloginviaapiflow) | **GET** /self-service/login/api | Initialize Login Flow for API clients
*PublicApi* | [**initializeSelfServiceLoginViaBrowserFlow**](doc//PublicApi.md#initializeselfserviceloginviabrowserflow) | **GET** /self-service/login/browser | Initialize Login Flow for browsers
*PublicApi* | [**initializeSelfServiceRecoveryViaAPIFlow**](doc//PublicApi.md#initializeselfservicerecoveryviaapiflow) | **GET** /self-service/recovery/api | Initialize Recovery Flow for API Clients
*PublicApi* | [**initializeSelfServiceRecoveryViaBrowserFlow**](doc//PublicApi.md#initializeselfservicerecoveryviabrowserflow) | **GET** /self-service/recovery/browser | Initialize Recovery Flow for Browser Clients
*PublicApi* | [**initializeSelfServiceRegistrationViaAPIFlow**](doc//PublicApi.md#initializeselfserviceregistrationviaapiflow) | **GET** /self-service/registration/api | Initialize Registration Flow for API clients
*PublicApi* | [**initializeSelfServiceRegistrationViaBrowserFlow**](doc//PublicApi.md#initializeselfserviceregistrationviabrowserflow) | **GET** /self-service/registration/browser | Initialize Registration Flow for browsers
*PublicApi* | [**initializeSelfServiceSettingsViaAPIFlow**](doc//PublicApi.md#initializeselfservicesettingsviaapiflow) | **GET** /self-service/settings/api | Initialize Settings Flow for API Clients
*PublicApi* | [**initializeSelfServiceSettingsViaBrowserFlow**](doc//PublicApi.md#initializeselfservicesettingsviabrowserflow) | **GET** /self-service/settings/browser | Initialize Settings Flow for Browsers
*PublicApi* | [**initializeSelfServiceVerificationViaAPIFlow**](doc//PublicApi.md#initializeselfserviceverificationviaapiflow) | **GET** /self-service/verification/api | Initialize Verification Flow for API Clients
*PublicApi* | [**initializeSelfServiceVerificationViaBrowserFlow**](doc//PublicApi.md#initializeselfserviceverificationviabrowserflow) | **GET** /self-service/verification/browser | Initialize Verification Flow for Browser Clients
*PublicApi* | [**revokeSession**](doc//PublicApi.md#revokesession) | **DELETE** /sessions | Revoke and Invalidate a Session
*PublicApi* | [**whoami**](doc//PublicApi.md#whoami) | **GET** /sessions/whoami | Check Who the Current HTTP Session Belongs To
*VersionApi* | [**getVersion**](doc//VersionApi.md#getversion) | **GET** /version | Get service version


## Documentation For Models

 - [CompleteSelfServiceLoginFlowWithPasswordMethod](doc//CompleteSelfServiceLoginFlowWithPasswordMethod.md)
 - [CompleteSelfServiceRecoveryFlowWithLinkMethod](doc//CompleteSelfServiceRecoveryFlowWithLinkMethod.md)
 - [CompleteSelfServiceSettingsFlowWithPasswordMethod](doc//CompleteSelfServiceSettingsFlowWithPasswordMethod.md)
 - [CompleteSelfServiceVerificationFlowWithLinkMethod](doc//CompleteSelfServiceVerificationFlowWithLinkMethod.md)
 - [CreateIdentity](doc//CreateIdentity.md)
 - [CreateRecoveryLink](doc//CreateRecoveryLink.md)
 - [ErrorContainer](doc//ErrorContainer.md)
 - [FormField](doc//FormField.md)
 - [GenericError](doc//GenericError.md)
 - [GenericErrorPayload](doc//GenericErrorPayload.md)
 - [HealthNotReadyStatus](doc//HealthNotReadyStatus.md)
 - [HealthStatus](doc//HealthStatus.md)
 - [Identity](doc//Identity.md)
 - [LoginFlow](doc//LoginFlow.md)
 - [LoginFlowMethod](doc//LoginFlowMethod.md)
 - [LoginFlowMethodConfig](doc//LoginFlowMethodConfig.md)
 - [LoginViaApiResponse](doc//LoginViaApiResponse.md)
 - [Message](doc//Message.md)
 - [RecoveryAddress](doc//RecoveryAddress.md)
 - [RecoveryFlow](doc//RecoveryFlow.md)
 - [RecoveryFlowMethod](doc//RecoveryFlowMethod.md)
 - [RecoveryFlowMethodConfig](doc//RecoveryFlowMethodConfig.md)
 - [RecoveryLink](doc//RecoveryLink.md)
 - [RegistrationFlow](doc//RegistrationFlow.md)
 - [RegistrationFlowMethod](doc//RegistrationFlowMethod.md)
 - [RegistrationFlowMethodConfig](doc//RegistrationFlowMethodConfig.md)
 - [RegistrationViaApiResponse](doc//RegistrationViaApiResponse.md)
 - [RevokeSession](doc//RevokeSession.md)
 - [Session](doc//Session.md)
 - [SettingsFlow](doc//SettingsFlow.md)
 - [SettingsFlowMethod](doc//SettingsFlowMethod.md)
 - [SettingsFlowMethodConfig](doc//SettingsFlowMethodConfig.md)
 - [SettingsViaApiResponse](doc//SettingsViaApiResponse.md)
 - [UpdateIdentity](doc//UpdateIdentity.md)
 - [VerifiableAddress](doc//VerifiableAddress.md)
 - [VerificationFlow](doc//VerificationFlow.md)
 - [VerificationFlowMethod](doc//VerificationFlowMethod.md)
 - [VerificationFlowMethodConfig](doc//VerificationFlowMethodConfig.md)
 - [Version](doc//Version.md)


## Documentation For Authorization


## sessionToken

- **Type**: API key
- **API key parameter name**: X-Session-Token
- **Location**: HTTP header


## Author




